diff -wrubN quake3_1.32b/code/unix/linux_glimp.c dfengine_1.07_src/code/unix/linux_glimp.c
--- quake3_1.32b/code/unix/linux_glimp.c	2009-04-18 19:29:36.000000000 +0200
+++ dfengine_1.07_src/code/unix/linux_glimp.c	2009-06-08 21:11:39.000000000 +0200
@@ -69,7 +69,9 @@
 #include <X11/extensions/xf86dga.h>
 #include <X11/extensions/xf86vmode.h>
 
-#define	WINDOW_CLASS_NAME	"Quake III: Arena"
+// Cgg
+#define	WINDOW_CLASS_NAME Q3_WINDOW_TITLE
+//"Quake III: Arena"
 
 typedef enum
 {
@@ -87,14 +89,18 @@
 static int scrnum;
 static Window win = 0;
 static GLXContext ctx = NULL;
+static XVisualInfo *visinfo = NULL; // drakkar - create once and reuse
 
 // bk001206 - not needed anymore
 // static qboolean autorepeaton = qtrue;
 
 #define KEY_MASK (KeyPressMask | KeyReleaseMask)
-#define MOUSE_MASK (ButtonPressMask | ButtonReleaseMask | \
-		    PointerMotionMask | ButtonMotionMask )
-#define X_MASK (KEY_MASK | MOUSE_MASK | VisibilityChangeMask | StructureNotifyMask )
+#define MOUSE_MASK (ButtonPressMask | ButtonReleaseMask | PointerMotionMask | ButtonMotionMask )
+// drakkar
+//- #define X_MASK (KEY_MASK | MOUSE_MASK | VisibilityChangeMask | StructureNotifyMask )
+#define WINDOW_MASK ( VisibilityChangeMask | StructureNotifyMask | FocusChangeMask )
+#define X_MASK ( KEY_MASK | MOUSE_MASK | WINDOW_MASK )
+// /drakkar
 
 static qboolean mouse_avail;
 static qboolean mouse_active = qfalse;
@@ -122,11 +128,20 @@
 static int vidmode_MajorVersion = 0, vidmode_MinorVersion = 0; // major and minor of XF86VidExtensions
 
 // gamma value of the X display before we start playing with it
-static XF86VidModeGamma vidmode_InitialGamma;
+static XF86VidModeGamma vidmode_InitialGamma = { -1,-1,-1 };  // drakkar - initialized to nonvalid values
 
-static int win_x, win_y;
+static int win_x = 50, win_y = 50;  // drakkar - initialize window position
 
-static XF86VidModeModeInfo **vidmodes;
+// drakkar
+qboolean win_active = qtrue;
+static qboolean win_minimized = qfalse;
+static qboolean windowModeLock = qtrue;
+static unsigned long int ignoreFocus = 0;
+static XF86VidModeModeInfo desktopVideoModeInfo = { 0,0,0,0,0,0,0,0,0,0,0,0 };
+static int desktopVideoMode = -1;
+// !drakkar
+
+static XF86VidModeModeInfo **vidmodes = NULL;  // drakkar - initialized to NULL
 //static int default_dotclock_vidmode; // bk001204 - unused
 static int num_vidmodes;
 static qboolean vidmode_active = qfalse;
@@ -282,6 +297,13 @@
   case XK_Alt_R:  
   case XK_Meta_R: *key = K_ALT;     break;
 
+  // drakkar
+  case XK_Super_L:
+  case XK_Super_R:  *key = K_WIN;     break;
+  
+  case XK_Menu:  *key = K_MENU;     break;
+  // !drakkar
+
   case XK_KP_Begin: *key = K_KP_5;  break;
 
   case XK_Insert:   *key = K_INS; break;
@@ -446,6 +468,19 @@
   XUndefineCursor(dpy, win);
 }
 
+
+// drakkar
+// Sys_MilliSeconds returns CPU usage time,
+// this fuction returns real time millisecons
+unsigned long int realMilliSeconds() 
+{
+	struct timeval tv;
+	gettimeofday( &tv, NULL );
+	return (unsigned long int)tv.tv_sec*1000 + (unsigned long int)tv.tv_usec/1000;
+}
+// !drakakr
+
+
 // bk001206 - from Ryan's Fakk2
 /**
  * XPending() actually performs a blocking read 
@@ -688,9 +723,26 @@
       break;
 
     case ConfigureNotify :
+		// drakkar - only user actions
+		if( glConfig.isFullscreen ) break;
+		if( win_active ) break;
+		if( event.xcreatewindow.x < 1 ) break;
+		if( event.xcreatewindow.y < 1 ) break;
+		// !drakkar
       win_x = event.xconfigure.x;
       win_y = event.xconfigure.y;
       break;
+	
+	// drakkar
+	case FocusIn:
+		if( ignoreFocus < realMilliSeconds() )
+			GLW_WindowFocus( qtrue );
+	break;
+	case FocusOut:
+		if( ignoreFocus < realMilliSeconds() )
+			GLW_WindowFocus( qfalse );
+	break;
+	// !drakkar
     }
   }
 
@@ -779,12 +831,14 @@
   // autorepeaton = qfalse; // bk001130 - from cvs1.17 (mkv)
   if (dpy)
   {
+	if( visinfo ) // drakkar
+	  XFree( visinfo );
     if (ctx)
       qglXDestroyContext(dpy, ctx);
     if (win)
       XDestroyWindow(dpy, win);
     if (vidmode_active)
-      XF86VidModeSwitchToMode(dpy, scrnum, vidmodes[0]);
+      XF86VidModeSwitchToMode(dpy, scrnum, vidmodes[desktopVideoMode]); // drakkar - replace 0 by desktopVideoMode
     if (glConfig.deviceSupportsGamma)
     {
       XF86VidModeSetGamma(dpy, scrnum, &vidmode_InitialGamma);
@@ -799,6 +853,11 @@
   dpy = NULL;
   win = 0;
   ctx = NULL;
+  // drakkar  
+  visinfo = NULL;
+  if( vidmodes ) XFree( vidmodes );
+  vidmodes = NULL;  
+  // !drakkar  
 
   memset( &glConfig, 0, sizeof( glConfig ) );
   memset( &glState, 0, sizeof( glState ) );
@@ -862,143 +921,63 @@
   return qtrue;
 }
 
-/*
-** GLW_SetMode
-*/
-int GLW_SetMode( const char *drivername, int mode, qboolean fullscreen )
-{
-  int attrib[] = {
-    GLX_RGBA,         // 0
-    GLX_RED_SIZE, 4,      // 1, 2
-    GLX_GREEN_SIZE, 4,      // 3, 4
-    GLX_BLUE_SIZE, 4,     // 5, 6
-    GLX_DOUBLEBUFFER,     // 7
-    GLX_DEPTH_SIZE, 1,      // 8, 9
-    GLX_STENCIL_SIZE, 1,    // 10, 11
-    None
-  };
-  // these match in the array
-#define ATTR_RED_IDX 2
-#define ATTR_GREEN_IDX 4
-#define ATTR_BLUE_IDX 6
-#define ATTR_DEPTH_IDX 9
-#define ATTR_STENCIL_IDX 11
-  Window root;
-  XVisualInfo *visinfo;
-  XSetWindowAttributes attr;
-  XSizeHints sizehints;
-  unsigned long mask;
-  int colorbits, depthbits, stencilbits;
-  int tcolorbits, tdepthbits, tstencilbits;
-  int dga_MajorVersion, dga_MinorVersion;
-  int actualWidth, actualHeight;
-  int i;
-  const char*   glstring; // bk001130 - from cvs1.17 (mkv)
-
-  ri.Printf( PRINT_ALL, "Initializing OpenGL display\n");
 
-  ri.Printf (PRINT_ALL, "...setting mode %d:", mode );
 
-  if ( !R_GetModeInfo( &glConfig.vidWidth, &glConfig.vidHeight, &glConfig.windowAspect, mode ) )
+// drakkar
+void GLW_WindowFocus(qboolean focus)
   {
-    ri.Printf( PRINT_ALL, " invalid mode\n" );
-    return RSERR_INVALID_MODE;
-  }
-  ri.Printf( PRINT_ALL, " %d %d\n", glConfig.vidWidth, glConfig.vidHeight);
+	if( !dpy || !win ) return;
 
-  if (!(dpy = XOpenDisplay(NULL)))
-  {
-    fprintf(stderr, "Error couldn't open the X display\n");
-    return RSERR_INVALID_MODE;
-  }
+	//Key_ClearStates();
   
-  scrnum = DefaultScreen(dpy);
-  root = RootWindow(dpy, scrnum);
+	R_SetColorMappings();
 
-  actualWidth = glConfig.vidWidth;
-  actualHeight = glConfig.vidHeight;
-
-  // Get video mode list
-  if (!XF86VidModeQueryVersion(dpy, &vidmode_MajorVersion, &vidmode_MinorVersion))
+	if( focus )
   {
-    vidmode_ext = qfalse;
-  } else
-  {
-    ri.Printf(PRINT_ALL, "Using XFree86-VidModeExtension Version %d.%d\n",
-              vidmode_MajorVersion, vidmode_MinorVersion);
-    vidmode_ext = qtrue;
+		if( win_minimized )
+			GLimp_WindowMode( WMODE_SWAP_MINIMIZED );
   }
-
-  // Check for DGA	
-  dga_MajorVersion = 0, dga_MinorVersion = 0;
-  if (in_dgamouse->value)
-  {
-    if (!XF86DGAQueryVersion(dpy, &dga_MajorVersion, &dga_MinorVersion))
-    {
-      // unable to query, probalby not supported
-      ri.Printf( PRINT_ALL, "Failed to detect XF86DGA Mouse\n" );
-      ri.Cvar_Set( "in_dgamouse", "0" );
-    } else
+	else
     {
-      ri.Printf( PRINT_ALL, "XF86DGA Mouse (Version %d.%d) initialized\n",
-                 dga_MajorVersion, dga_MinorVersion);
+		if( glConfig.deviceSupportsGamma )
+			XF86VidModeSetGamma( dpy, scrnum, &vidmode_InitialGamma );
+		if( glConfig.isFullscreen )
+			GLimp_WindowMode( WMODE_SWAP_MINIMIZED );
     }
+
+	win_active = ( focus && !win_minimized );
   }
+// !drakkar
 
-  if (vidmode_ext)
-  {
-    int best_fit, best_dist, dist, x, y;
 
-    XF86VidModeGetAllModeLines(dpy, scrnum, &num_vidmodes, &vidmodes);
 
-    // Are we going fullscreen?  If so, let's change video mode
-    if (fullscreen)
-    {
-      best_dist = 9999999;
-      best_fit = -1;
 
-      for (i = 0; i < num_vidmodes; i++)
-      {
-        if (glConfig.vidWidth > vidmodes[i]->hdisplay ||
-            glConfig.vidHeight > vidmodes[i]->vdisplay)
-          continue;
-
-        x = glConfig.vidWidth - vidmodes[i]->hdisplay;
-        y = glConfig.vidHeight - vidmodes[i]->vdisplay;
-        dist = (x * x) + (y * y);
-        if (dist < best_dist)
-        {
-          best_dist = dist;
-          best_fit = i;
-        }
-      }
 
-      if (best_fit != -1)
-      {
-        actualWidth = vidmodes[best_fit]->hdisplay;
-        actualHeight = vidmodes[best_fit]->vdisplay;
 
-        // change to the mode
-        XF86VidModeSwitchToMode(dpy, scrnum, vidmodes[best_fit]);
-        vidmode_active = qtrue;
 
-        // Move the viewport to top left
-        XF86VidModeSetViewPort(dpy, scrnum, 0, 0);
-
-        ri.Printf(PRINT_ALL, "XFree86-VidModeExtension Activated at %dx%d\n",
-                  actualWidth, actualHeight);
+#define ATTR_RED_IDX		2
+#define ATTR_GREEN_IDX		4
+#define ATTR_BLUE_IDX		6
+#define ATTR_DEPTH_IDX		9
+#define ATTR_STENCIL_IDX	11
 
-      } else
+XVisualInfo * createVisualInfo(Display *dpy, int scrnum)
       {
-        fullscreen = 0;
-        ri.Printf(PRINT_ALL, "XFree86-VidModeExtension: No acceptable modes found\n");
-      }
-    } else
-    {
-      ri.Printf(PRINT_ALL, "XFree86-VidModeExtension:  Ignored on non-fullscreen/Voodoo\n");
-    }
-  }
+  XVisualInfo *visinfo = NULL;
+  int colorbits, depthbits, stencilbits;
+  int tcolorbits, tdepthbits, tstencilbits;
+  int i;
 
+  int attrib[] = {
+    GLX_RGBA,			// 0
+    GLX_RED_SIZE, 4,	// 1, 2
+    GLX_GREEN_SIZE, 4,	// 3, 4
+    GLX_BLUE_SIZE, 4,	// 5, 6
+    GLX_DOUBLEBUFFER,	// 7
+    GLX_DEPTH_SIZE, 1,	// 8, 9
+    GLX_STENCIL_SIZE, 1,// 10, 11
+    None
+  };
 
   if (!r_colorbits->value)
     colorbits = 24;
@@ -1102,53 +1081,254 @@
     break;
   }
 
-  if (!visinfo)
-  {
-    ri.Printf( PRINT_ALL, "Couldn't get a visual\n" );
-    return RSERR_INVALID_MODE;
+  return visinfo;
   }
 
-  /* window attributes */
+
+
+Window createWindow(Display *dpy, int scrnum, Window root, XVisualInfo *visinfo, qboolean fullscreen, int x, int y)
+{
+	XSetWindowAttributes attr;
+	XSizeHints sizehints;
+	unsigned long mask;
+	Window win;
+	
   attr.background_pixel = BlackPixel(dpy, scrnum);
   attr.border_pixel = 0;
   attr.colormap = XCreateColormap(dpy, root, visinfo->visual, AllocNone);
+	attr.backing_store = NotUseful;
+	attr.save_under = False;
   attr.event_mask = X_MASK;
-  if (vidmode_active)
+	mask = CWEventMask | CWBackPixel | CWBorderPixel | CWColormap | CWBackingStore | CWSaveUnder;
+
+  	if( fullscreen )
   {
-    mask = CWBackPixel | CWColormap | CWSaveUnder | CWBackingStore | 
-           CWEventMask | CWOverrideRedirect;
+		mask |= CWOverrideRedirect;
     attr.override_redirect = True;
-    attr.backing_store = NotUseful;
-    attr.save_under = False;
-  } else
-    mask = CWBackPixel | CWBorderPixel | CWColormap | CWEventMask;
+		x = 0;
+		y = 0;
+	}
 
-  win = XCreateWindow(dpy, root, 0, 0, 
-                      actualWidth, actualHeight, 
+	win = XCreateWindow( dpy, root,
+						 x, y,  glConfig.vidWidth, glConfig.vidHeight, 
                       0, visinfo->depth, InputOutput,
                       visinfo->visual, mask, &attr);
-
+	if( !win ) return 0;
   XStoreName( dpy, win, WINDOW_CLASS_NAME );
 
-  /* GH: Don't let the window be resized */
-  sizehints.flags = PMinSize | PMaxSize;
-  sizehints.min_width = sizehints.max_width = actualWidth;
-  sizehints.min_height = sizehints.max_height = actualHeight;
+	XMapWindow( dpy, win );	
+	XFlush(dpy);
+
+	XMoveWindow( dpy, win, x, y );
 
+	// GH: Don't let the window be resized
+	sizehints.flags = PMinSize | PMaxSize;
+	sizehints.min_width = sizehints.max_width = glConfig.vidWidth;
+	sizehints.min_height = sizehints.max_height = glConfig.vidHeight;
   XSetWMNormalHints( dpy, win, &sizehints );
 
-  XMapWindow( dpy, win );
+	XFlush(dpy);
 
-  if (vidmode_active)
-    XMoveWindow(dpy, win, 0, 0);
+	return win;
+}
 
-  XFlush(dpy);
+
+qboolean switchToMode(Display *dpy, int scrnum, qboolean fullscreen)
+{
+  if (!XF86VidModeQueryVersion(dpy, &vidmode_MajorVersion, &vidmode_MinorVersion))
+  {
+    vidmode_ext = qfalse;
+	// drakkar
+	fullscreen = qfalse;
+	vidmode_active = qfalse;
+	// !drakkar
+  } else
+  {
+    ri.Printf(PRINT_ALL, "Using XFree86-VidModeExtension Version %d.%d\n",
+              vidmode_MajorVersion, vidmode_MinorVersion);
+    vidmode_ext = qtrue;
+  }
+  
+  if (vidmode_ext)
+  {
+    int best_fit, best_dist, dist, x, y, i;
+
+	if( vidmodes ) XFree( vidmodes ); // drakkar
+	XF86VidModeGetAllModeLines(dpy, scrnum, &num_vidmodes, &vidmodes);
+
+	// drakkar
+	// search desktop video mode:
+	// first time vidmodes[0] is always the desktop video mode ( we come from desktop )
+	// but vidmodes[0] is not always the desktop video mode in some graphic card drivers
+	if( desktopVideoModeInfo.hdisplay == 0 ) // first time, desktop mode = vidmodes[0]
+	{
+		desktopVideoModeInfo = *vidmodes[0];
+		desktopVideoMode = 0;
+	}
+	else // desktop mode = one in vidmodes array, normally vidmodes[0]
+	{
+		desktopVideoMode = 0;
+		for( i = 0; i < num_vidmodes; i++ )
+		{
+			dist = memcmp( vidmodes[i], &desktopVideoModeInfo, sizeof(*vidmodes[i])-sizeof(vidmodes[i]->private) );
+			if( !dist )
+			{
+				desktopVideoMode = i;
+				break;
+			}
+		}
+	}
+	// !drakkar
+
+    // Are we going fullscreen?  If so, let's change video mode
+    if (fullscreen)
+    {
+      best_dist = 9999999;
+      best_fit = -1;
+
+      for (i = 0; i < num_vidmodes; i++)
+      {
+        if (glConfig.vidWidth  > vidmodes[i]->hdisplay || glConfig.vidHeight > vidmodes[i]->vdisplay)
+          continue;
+
+        x = glConfig.vidWidth  - vidmodes[i]->hdisplay;
+        y = glConfig.vidHeight - vidmodes[i]->vdisplay;
+        dist = (x * x) + (y * y);
+        if (dist < best_dist)
+        {
+          best_dist = dist;
+          best_fit = i;
+        }
+      }
+
+      if (best_fit != -1)
+      {
+        glConfig.vidWidth  = vidmodes[best_fit]->hdisplay;
+        glConfig.vidHeight = vidmodes[best_fit]->vdisplay;
+
+        // change to the mode
+        XF86VidModeSwitchToMode(dpy, scrnum, vidmodes[best_fit]);
+		XFlush( dpy );  // drakkar - man 3 XF86VidModeSwitchToMode 
+        vidmode_active = qtrue;
+        // Move the viewport to top left
+		if( win ) XMoveWindow( dpy, win, 0, 0 ); // drakkar - XF86VidModeSetViewPort problems if windows is placed out of screen
+        XF86VidModeSetViewPort(dpy, scrnum, 0, 0);
+
+        ri.Printf(PRINT_ALL, "XFree86-VidModeExtension Activated at %dx%d\n", glConfig.vidWidth, glConfig.vidHeight);
+
+      } else
+      {
+        fullscreen = 0;
+        ri.Printf(PRINT_ALL, "XFree86-VidModeExtension: No acceptable modes found\n");
+      }
+    }
+	// drakkar	
+//- else
+//- {
+//-   ri.Printf(PRINT_ALL, "XFree86-VidModeExtension:  Ignored on non-fullscreen/Voodoo\n");
+//- }
+	
+	if( !fullscreen )
+    {
+		vidmode_active = qfalse;
+		XF86VidModeSwitchToMode( dpy, scrnum, vidmodes[desktopVideoMode] );
+		ri.Printf(PRINT_ALL, "XFree86-VidModeExtension:  No fullscreen\n");
+    }
+	// !drakkar
+  }
+	
+	glConfig.isFullscreen = fullscreen;
+
+	return fullscreen;
+}
+
+
+/*
+** GLW_SetMode
+*/
+int GLW_SetMode( const char *drivername, int mode, qboolean fullscreen )
+{  
+  int dga_MajorVersion, dga_MinorVersion;
+  const char*   glstring; // bk001130 - from cvs1.17 (mkv)
+  Window root = 0;
+
+
+  ri.Printf( PRINT_ALL, "Initializing OpenGL display\n");
+
+  ri.Printf (PRINT_ALL, "...setting mode %d:", mode );
+
+  if ( !R_GetModeInfo( &glConfig.vidWidth, &glConfig.vidHeight, &glConfig.windowAspect, mode ) )
+  {
+    ri.Printf( PRINT_ALL, " invalid mode\n" );
+    return RSERR_INVALID_MODE;
+  }
+  ri.Printf( PRINT_ALL, " %d %d\n", glConfig.vidWidth, glConfig.vidHeight);
+
+	if( !dpy ) // drakkar - skip if display already opened
+	{
+		dpy = XOpenDisplay( NULL );
+		if( !dpy )
+		{
+			fprintf(stderr, "Error couldn't open the X display\n");
+			return RSERR_INVALID_MODE;
+		}
+	}  
+  
+  scrnum = DefaultScreen(dpy);
+  root = RootWindow(dpy, scrnum);
+
+  // Check for DGA	
+  dga_MajorVersion = 0, dga_MinorVersion = 0;
+  if (in_dgamouse->value)
+  {
+    if (!XF86DGAQueryVersion(dpy, &dga_MajorVersion, &dga_MinorVersion))
+    {
+      // unable to query, probalby not supported
+      ri.Printf( PRINT_ALL, "Failed to detect XF86DGA Mouse\n" );
+      ri.Cvar_Set( "in_dgamouse", "0" );
+    } else
+    {
+      ri.Printf( PRINT_ALL, "XF86DGA Mouse (Version %d.%d) initialized\n",
+                 dga_MajorVersion, dga_MinorVersion);
+    }
+  }
+
+	// drakkar
+	// moved some code to switchToMode function
+	fullscreen = switchToMode( dpy, scrnum, fullscreen );
+	win_minimized = qfalse;
+
+	// moved visual info code to createVisualInfo function
+	if( !visinfo )
+	{
+		visinfo = createVisualInfo( dpy, scrnum );
+		if( !visinfo )
+		{
+			ri.Printf( PRINT_ALL, "Couldn't get a visual\n" );
+			return RSERR_INVALID_MODE;
+		}
+	}
+	
+	// moved window code to createWindow function
+	IN_DeactivateMouse();
+	ignoreFocus = 10000 + realMilliSeconds();
+	if( win ) XDestroyWindow( dpy, win );
+	win = createWindow( dpy, scrnum, root, visinfo, fullscreen, win_x, win_y );
+	if( !win )
+	{
+		ri.Printf( PRINT_ALL, "Couldn't create the window\n" );
+		return RSERR_INVALID_MODE;
+	}
+	IN_ActivateMouse();
+	ignoreFocus = 500 + realMilliSeconds();
+	// !drakkar
+
+	if( !ctx )  // drakkar - skip if context already created
+	{
   XSync(dpy,False); // bk001130 - from cvs1.17 (mkv)
   ctx = qglXCreateContext(dpy, visinfo, NULL, True);
   XSync(dpy,False); // bk001130 - from cvs1.17 (mkv)
-
-  /* GH: Free the visinfo after we're done with it */
-  XFree( visinfo );
+	}
 
   qglXMakeCurrent(dpy, win, ctx);
 
@@ -1180,6 +1360,7 @@
   return RSERR_OK;
 }
 
+
 /*
 ** GLW_InitExtensions
 */
@@ -1303,6 +1484,7 @@
       ri.Printf( PRINT_ALL, "XF86 Gamma extension not supported in this version\n");
       return;
     }
+	if( vidmode_InitialGamma.red < 0 ) // drakkar - get initial gamma only one time
     XF86VidModeGetGamma(dpy, scrnum, &vidmode_InitialGamma);
     ri.Printf( PRINT_ALL, "XF86 Gamma extension initialized\n");
     glConfig.deviceSupportsGamma = qtrue;
@@ -1334,6 +1516,10 @@
   {
     fullscreen = r_fullscreen->integer;
 
+	// drakkar
+	windowModeLock = qfalse;
+	// !drakkar
+	  
     // create the window and set up the context
     if ( !GLW_StartDriverAndSetMode( name, r_mode->integer, fullscreen ) )
     {
@@ -1347,6 +1533,10 @@
         goto fail;
     }
 
+	// drakkar
+	windowModeLock = qtrue;
+	// !drakkar
+
     return qtrue;
   } else
   {
@@ -1377,6 +1567,81 @@
   return 0;
 }
 
+
+// drakkar
+/*
+** GLimp_WindowMode
+**
+** Changes window mode ( minimized, windowed, fullscreen ) without vid_restart.
+*/
+void GLimp_WindowMode( windowMode_t wmode )
+{
+	if( !windowModeLock ) return;
+
+	switch( wmode )
+	{
+		case WMODE_SET_MINIMIZED:
+			windowModeLock = qfalse;
+			GLW_StartDriverAndSetMode( r_glDriver->string, r_mode->integer, qfalse );
+			XIconifyWindow( dpy, win, scrnum );
+			win_minimized = qtrue;
+			GLW_WindowFocus( qfalse );
+			windowModeLock = qtrue;
+		break;
+		
+		case WMODE_SET_WINDOWED:
+			windowModeLock = qfalse;
+			GLW_StartDriverAndSetMode( r_glDriver->string, r_mode->integer, qfalse );
+			win_minimized = qfalse;
+			GLW_WindowFocus( qtrue );
+			uninstall_grabs();
+			install_grabs();
+			windowModeLock = qtrue;
+			ri.Cvar_Set( "r_fullscreen", "0" );
+			if( glConfig.isFullscreen )
+				Cbuf_AddText( "vid_restart\n" );
+		break;
+		
+		case WMODE_SET_FULLSCREEN:
+			windowModeLock = qfalse;
+			GLW_StartDriverAndSetMode( r_glDriver->string, r_mode->integer, qtrue );
+			win_minimized = qfalse;
+			GLW_WindowFocus( qtrue );
+			windowModeLock = qtrue;
+			ri.Cvar_Set( "r_fullscreen", "1" );
+			if( !glConfig.isFullscreen )
+				Cbuf_AddText( "vid_restart\n" );
+		break;
+		
+		case WMODE_RESTART:
+			if( r_fullscreen->modified && r_fullscreen->latchedString )
+			{
+				if( !Q_strncmp( r_fullscreen->latchedString, "0", 1 ) )
+					GLimp_WindowMode( WMODE_SET_WINDOWED );
+				else
+					GLimp_WindowMode( WMODE_SET_FULLSCREEN );
+			}
+			else
+			{
+				GLimp_WindowMode( r_fullscreen->integer ? WMODE_SET_FULLSCREEN : WMODE_SET_WINDOWED );
+			}
+		break;
+		
+		case WMODE_SWAP_FULLSCREEN:
+			GLimp_WindowMode( glConfig.isFullscreen ? WMODE_SET_WINDOWED : WMODE_SET_FULLSCREEN );
+		break;		
+		
+		case WMODE_SWAP_MINIMIZED:
+			GLimp_WindowMode( win_minimized ? WMODE_RESTART : WMODE_SET_MINIMIZED );
+		break;
+		
+		default:
+			Com_Printf( "Invalid Window Mode\n" );
+	}
+}
+// !drakkar
+
+
 /*
 ** GLimp_Init
 **
@@ -1753,7 +2018,13 @@
     }
   }
 
+	// drakkar
+//-  IN_ActivateMouse();
+	if( win_active )
   IN_ActivateMouse();
+	else
+		IN_DeactivateMouse();
+	// !drakkar
 }
 
 void IN_Activate(void)
diff -wrubN quake3_1.32b/code/unix/linux_local.h dfengine_1.07_src/code/unix/linux_local.h
--- quake3_1.32b/code/unix/linux_local.h	2009-04-18 19:29:36.000000000 +0200
+++ dfengine_1.07_src/code/unix/linux_local.h	2009-05-21 14:53:03.000000000 +0200
@@ -47,3 +47,13 @@
 
 // signals.c
 void InitSig(void);
+
+
+// drakkar
+void GLW_WindowFocus(qboolean focus);
+// !drakkar
+
+// drakkar - main need this to do sleep() if window not active
+extern qboolean win_active;
+// !drakkar
+
diff -wrubN quake3_1.32b/code/unix/unix_main.c dfengine_1.07_src/code/unix/unix_main.c
--- quake3_1.32b/code/unix/unix_main.c	2009-04-18 19:29:36.000000000 +0200
+++ dfengine_1.07_src/code/unix/unix_main.c	2009-05-27 12:44:05.000000000 +0200
@@ -1219,6 +1219,11 @@
 
 #include "../client/client.h"
 extern clientStatic_t cls;
+#ifdef __linux__
+#ifndef DEDICATED
+extern qboolean win_active;	// drakkar
+#endif
+#endif
 
 int main ( int argc, char* argv[] )
 {
@@ -1267,7 +1272,15 @@
   {
 #ifdef __linux__
     Sys_ConfigureFPU();
-#endif
+#ifndef DEDICATED
+	// drakkar
+	if( !win_active )
+	{
+		usleep( 100000 );  // 10 fps, free CPU
+	}
+	// !drakkar
+#endif	// !DEDICATED
+#endif	// __linux__
     Com_Frame ();
   }
 }
diff -wrubN quake3_1.32b/code/win32/win_glimp.c dfengine_1.07_src/code/win32/win_glimp.c
--- quake3_1.32b/code/win32/win_glimp.c	2009-04-18 19:29:36.000000000 +0200
+++ dfengine_1.07_src/code/win32/win_glimp.c	2009-05-22 21:11:14.000000000 +0200
@@ -67,6 +67,10 @@
 
 static qboolean s_classRegistered = qfalse;
 
+// drakkar
+static qboolean windowModeLock = qtrue;
+// !drakkar
+
 //
 // function declaration
 //
@@ -568,11 +572,147 @@
 	return qtrue;
 }
 
+
 /*
 ** GLW_CreateWindow
 **
 ** Responsible for creating the Win32 window and initializing the OpenGL driver.
 */
+// drakkar - some changes to allow swap between fullscreen and windowed
+#define	WINDOW_STYLE	        (WS_OVERLAPPED|WS_BORDER|WS_CAPTION|WS_VISIBLE)
+#define WINDOW_STYLE_NORMAL     (WINDOW_STYLE|WS_SYSMENU|WS_MINIMIZEBOX|WS_MAXIMIZEBOX)
+#define WINDOW_STYLE_FULLSCREEN (WS_POPUP|WS_VISIBLE|WS_SYSMENU|WS_MAXIMIZE)
+static qboolean GLW_CreateWindow( const char *drivername, int width, int height, int colorbits, qboolean cdsFullscreen )
+{
+	RECT			r;
+	cvar_t			*vid_xpos, *vid_ypos;
+	int				stylebits;
+	int				x, y, w, h;
+	int				exstyle;
+
+	// register the window class if necessary
+	if ( !s_classRegistered )
+	{
+		WNDCLASS wc;
+
+		memset( &wc, 0, sizeof( wc ) );
+
+		wc.style         = 0;
+		wc.lpfnWndProc   = (WNDPROC) glw_state.wndproc;
+		wc.cbClsExtra    = 0;
+		wc.cbWndExtra    = 0;
+		wc.hInstance     = g_wv.hInstance;
+		wc.hIcon         = LoadIcon( g_wv.hInstance, MAKEINTRESOURCE(IDI_ICON1));
+		wc.hCursor       = LoadCursor (NULL,IDC_ARROW);
+		wc.hbrBackground = (void *)COLOR_GRAYTEXT;
+		wc.lpszMenuName  = 0;
+		wc.lpszClassName = WINDOW_CLASS_NAME;
+
+		if ( !RegisterClass( &wc ) )
+		{
+			ri.Error( ERR_FATAL, "GLW_CreateWindow: could not register window class" );
+		}
+		s_classRegistered = qtrue;
+		ri.Printf( PRINT_ALL, "...registered window class\n" );
+	}
+
+	cdsFullscreen = ( cdsFullscreen || !Q_stricmp( _3DFX_DRIVER_NAME, drivername ) );
+	g_wv.isMinimized = qfalse;
+
+	if( cdsFullscreen )
+	{
+		exstyle = WS_EX_TOPMOST;
+		stylebits = WINDOW_STYLE_FULLSCREEN;
+	}
+	else
+	{
+		exstyle = 0;
+		stylebits = WINDOW_STYLE_NORMAL;
+	}
+
+	r.left = 0;
+	r.top = 0;
+	r.right  = width;
+	r.bottom = height;
+
+	AdjustWindowRect( &r, stylebits, FALSE );
+
+	w = r.right - r.left;
+	h = r.bottom - r.top;
+
+	if ( cdsFullscreen )
+	{
+		x = 0;
+		y = 0;
+	}
+	else
+	{
+		vid_xpos = ri.Cvar_Get ("vid_xpos", "", 0);
+		vid_ypos = ri.Cvar_Get ("vid_ypos", "", 0);
+		x = vid_xpos->integer;
+		y = vid_ypos->integer;
+
+		// adjust window coordinates if necessary 
+		// so that the window is completely on screen
+		if ( x < 0 ) x = 0;
+		if ( y < 0 ) y = 0;
+
+		if ( w < glw_state.desktopWidth && h < glw_state.desktopHeight )
+		{
+			if ( x + w > glw_state.desktopWidth )
+				x = ( glw_state.desktopWidth - w );
+			if ( y + h > glw_state.desktopHeight )
+				y = ( glw_state.desktopHeight - h );
+		}
+	}
+
+	// create the HWND if one does not already exist
+	if ( !g_wv.hWnd )
+	{
+		g_wv.hWnd = CreateWindowEx (
+			 exstyle, 
+			 WINDOW_CLASS_NAME,
+			 Q3_WINDOW_TITLE,
+			 stylebits,
+			 x, y, w, h,
+			 NULL,
+			 NULL,
+			 g_wv.hInstance,
+			 NULL);
+
+		if ( !g_wv.hWnd )
+		{
+			ri.Error (ERR_FATAL, "GLW_CreateWindow() - Couldn't create window");
+		}
+	
+		ri.Printf( PRINT_ALL, "...created window@%d,%d (%dx%d)\n", x, y, w, h );
+	}
+	else
+	{
+		ri.Printf( PRINT_ALL, "...window already present, CreateWindowEx skipped\n" );
+		SetWindowLong( g_wv.hWnd, GWL_STYLE, stylebits );
+		SetWindowLong( g_wv.hWnd, GWL_EXSTYLE, exstyle );
+		SetWindowPos( g_wv.hWnd, cdsFullscreen?HWND_TOPMOST:HWND_NOTOPMOST, x,y, w,h, SWP_SHOWWINDOW );
+	}
+
+	ShowWindow( g_wv.hWnd, SW_SHOW );
+	UpdateWindow( g_wv.hWnd );
+
+	if ( !GLW_InitDriver( drivername, colorbits ) )
+	{
+		ShowWindow( g_wv.hWnd, SW_HIDE );
+		DestroyWindow( g_wv.hWnd );
+		g_wv.hWnd = NULL;
+
+		return qfalse;
+	}
+
+	SetForegroundWindow( g_wv.hWnd );
+	SetFocus( g_wv.hWnd );
+
+	return qtrue;
+}
+/* // original version
 #define	WINDOW_STYLE	(WS_OVERLAPPED|WS_BORDER|WS_CAPTION|WS_VISIBLE)
 static qboolean GLW_CreateWindow( const char *drivername, int width, int height, int colorbits, qboolean cdsFullscreen )
 {
@@ -670,7 +810,7 @@
 		g_wv.hWnd = CreateWindowEx (
 			 exstyle, 
 			 WINDOW_CLASS_NAME,
-			 "Quake 3: Arena",
+			 Q3_WINDOW_TITLE,	// Cgg
 			 stylebits,
 			 x, y, w, h,
 			 NULL,
@@ -706,6 +846,36 @@
 
 	return qtrue;
 }
+*/  // !original version
+// !drakkar
+
+
+// drakkar
+void GLW_WindowFocus(qboolean focus)
+{
+	if( !g_wv.hWnd ) return;
+
+	R_SetColorMappings();
+
+	if( focus )
+	{
+		//Key_ClearStates();
+		if( g_wv.isMinimized )
+			GLimp_WindowMode( WMODE_SWAP_MINIMIZED );
+	}
+	else
+	{
+		WG_RestoreGamma();
+		if( glConfig.isFullscreen )
+			GLimp_WindowMode( WMODE_SWAP_MINIMIZED );
+	}
+
+	g_wv.activeApp = ( focus && !g_wv.isMinimized );
+	IN_Activate( g_wv.activeApp );
+	SNDDMA_Activate();
+}
+// !drakkar
+
 
 static void PrintCDSError( int value )
 {
@@ -1201,6 +1371,10 @@
 	{
 		cdsFullscreen = r_fullscreen->integer;
 
+		// drakkar
+		windowModeLock = qfalse;
+		// !drakkar
+
 		// create the window and set up the context
 		if ( !GLW_StartDriverAndSetMode( drivername, r_mode->integer, r_colorbits->integer, cdsFullscreen ) )
 		{
@@ -1229,6 +1403,10 @@
 			glConfig.isFullscreen = qtrue;
 		}
 
+		// drakkar
+		windowModeLock = qtrue;
+		// !drakkar
+
 		return qtrue;
 	}
 fail:
@@ -1337,6 +1515,82 @@
 	}
 }
 
+
+// drakkar
+/*
+** GLimp_WindowMode
+**
+** Changes window mode ( minimized, windowed, fullscreen ) without vid_restart.
+*/
+void GLimp_WindowMode( windowMode_t wmode )
+{
+	if( !windowModeLock )	return;	
+
+	switch( wmode )
+	{
+		case WMODE_SET_MINIMIZED:
+			windowModeLock = qfalse;
+			glw_state.cdsFullscreen = qfalse;
+			ChangeDisplaySettings( 0, 0 );
+			ShowWindow( g_wv.hWnd, SW_SHOWMINIMIZED );			
+			g_wv.isMinimized = qtrue;
+			GLW_WindowFocus( qfalse );
+			windowModeLock = qtrue;
+		break;
+		
+		case WMODE_SET_WINDOWED:
+			windowModeLock = qfalse;
+			GLW_StartDriverAndSetMode( r_glDriver->string, r_mode->integer, r_colorbits->integer, qfalse );
+			ShowWindow( g_wv.hWnd, SW_SHOWNORMAL );
+			g_wv.isMinimized = qfalse;
+			GLW_WindowFocus( qtrue );
+			windowModeLock = qtrue;
+			ri.Cvar_Set( "r_fullscreen", "0" );
+			if( glConfig.isFullscreen )
+				Cbuf_AddText( "vid_restart\n" );
+		break;
+		
+		case WMODE_SET_FULLSCREEN:
+			windowModeLock = qfalse;
+			GLW_StartDriverAndSetMode( r_glDriver->string, r_mode->integer, r_colorbits->integer, qtrue );
+			ShowWindow( g_wv.hWnd, SW_SHOWMAXIMIZED );				
+			g_wv.isMinimized = qfalse;
+			GLW_WindowFocus( qtrue );
+			windowModeLock = qtrue;
+			ri.Cvar_Set( "r_fullscreen", "1" );
+			if( !glConfig.isFullscreen )
+				Cbuf_AddText( "vid_restart\n" );
+		break;
+		
+		case WMODE_RESTART:
+			if( r_fullscreen->modified && r_fullscreen->latchedString )
+			{
+				if( !Q_strncmp( r_fullscreen->latchedString, "0", 1 ) )
+					GLimp_WindowMode( WMODE_SET_WINDOWED );
+				else
+					GLimp_WindowMode( WMODE_SET_FULLSCREEN );
+			}
+			else
+			{
+				GLimp_WindowMode( r_fullscreen->integer ? WMODE_SET_FULLSCREEN : WMODE_SET_WINDOWED );
+			}
+		break;
+		
+		case WMODE_SWAP_FULLSCREEN:
+			GLimp_WindowMode( glConfig.isFullscreen ? WMODE_SET_WINDOWED : WMODE_SET_FULLSCREEN );
+		break;		
+		
+		case WMODE_SWAP_MINIMIZED:
+			GLimp_WindowMode( g_wv.isMinimized ? WMODE_RESTART : WMODE_SET_MINIMIZED );
+		break;
+		
+		default:
+			Com_Printf( "Invalid Window Mode\n" );
+	}
+}
+// !drakkar
+
+
 /*
 ** GLimp_Init
 **
